// DialogTSPL.cpp : ʵļ
//

#include "stdafx.h"
#include "TestPOS.h"
#include "DialogTSPL.h"

//TSPL
#define TSPL_PRINTER_STATUS_OUTPAPER 1L	//ӡȱֽ
#define TSPL_PRINTER_STATUS_WORK 2L	//ӡ
#define TSPL_PRINTER_STATUS_ENCLOSURENOCLOSE 3L	//δ
#define TSPL_PRINTER_STATUS_ERROR 4L	//ӡڲ

#define TSPL_PARAM_LESS_EQUAL_ZERO		-2L		//Сڵ0
#define TSPL_PARAM_GREAT_RANGE          -3L		//ָΧ
#define TSPL_PARAM_INVALID              -4L
#define TSPL_SUCCESS					0L
#define TSPL_IDERROR					-1L

//Dimensional barcode type
#define TSPL_BT_PDF417		4100L
#define TSPL_BT_DATAMATRIX	4101L
#define TSPL_BT_QRCODE		4102L


//ҳҳ
typedef LONG (WINAPI *CallPageSetupTSPL)(LONG iPrinterID,INT PageWidth, INT PageHeight);

//
typedef LONG (WINAPI *CallDrawLineTSPL)(LONG iPrinterID,INT StartX, INT StartY, INT LineWidth, INT LineHeight);

//TL51ӡ
typedef LONG (WINAPI *CallPrintTSPL51)(LONG iPrinterID,INT Set, INT Copy);

//
typedef LONG (WINAPI *CallDrawBorderTSPL)(LONG iPrinterID,INT LineWidth, INT top_left_x, INT top_left_y, INT bottom_right_x, INT bottom_right_y);

//
typedef LONG (WINAPI *CallDrawTextTSPL)(LONG iPrinterID,INT start_x, INT start_y, BOOL isSimplifiedChinese, INT xMultiplication,INT yMultiplication, INT rotate, LPCSTR content);

//һά
typedef LONG (WINAPI *CallDrawBarCodeTSPL)(LONG iPrinterID,INT start_x, INT start_y, CString type, INT height, BOOL isReadable,INT rotate, INT narrowWidth, INT wideWidth, LPCSTR content);

//ջ
typedef LONG (WINAPI *CallClearBuffTSPL)(LONG iPrinterID);

//ά
typedef LONG (WINAPI *CallDraw2DBarCodeTSPL)(LONG iPrinterID,INT itype, INT start_x, INT start_y, INT para1, INT para2, INT para3 ,LPCSTR content);

//λͼ
typedef LONG (WINAPI *CallDownLoadBitMapTSPL)(LONG iPrinterID,BOOL isMoveFlash,LPCTSTR PathName);

//ͼƬˢ
typedef LONG (WINAPI *CallPutBitMapTSPL)(LONG iPrinterID,INT start_x, INT start_y,LPCTSTR fileName);

//ͼƬ
typedef LONG (WINAPI *CallDrawBitMapTSPL)(LONG iPrinterID, INT start_x, INT start_y, INT mode, LPCSTR fileName);

//õӡ״̬
typedef LONG (WINAPI *CallGetPrinterStatusTSPL)(LONG iPrinterID);

//Ʒһ
typedef LONG (WINAPI *CallDriveBeepTSPL)(LONG iPrinterID);

//ùַ
typedef LONG (WINAPI *CallSetCharsetNameTSPL)(LONG iPrinterID,CString CharsetName);

//ƽֽֽ
typedef LONG (WINAPI *CallSetPaperbackOrPaperFeedTSPL)(LONG iPrinterID,BOOL isFeedBack, INT mDot);

//ָӡ
typedef LONG (WINAPI *CallReverseAreaTSPL)(LONG iPrinterID,INT start_x, INT start_y, INT width, INT height);

//ѡַҳ
typedef LONG (WINAPI *CallSelectCodePageTSPL)(LONG iPrinterID,INT value);

//ñǩ䴹ֱ
typedef LONG (WINAPI *CallSetGAPTSPL)(LONG iPrinterID,DOUBLE value);

//ǩĲοԭ
typedef LONG (WINAPI *CallSetLabelReferenceTSPL)(LONG iPrinterID,INT x,INT y);

//TL21ӡ
typedef LONG (WINAPI *CallPrintTSPL21)(LONG iPrinterID,INT Set);

//ȷϻTL21ڲָԼ
typedef LONG (WINAPI *CallSetIs21)();

//ôӡɫ
typedef LONG (WINAPI *CallSetPrintColorTSPL)(LONG iPrinterID,INT iColor);


extern CallPageSetupTSPL						PageSetupTSPL;
extern CallDrawLineTSPL							DrawLineTSPL;
extern CallPrintTSPL51							PrintTSPL51;
extern CallDrawBorderTSPL						DrawBorderTSPL;
extern CallDrawTextTSPL							DrawTextTSPL;
extern CallDrawBarCodeTSPL						DrawBarCodeTSPL;
extern CallClearBuffTSPL						ClearBuffTSPL;
extern CallDraw2DBarCodeTSPL					Draw2DBarCodeTSPL;
extern CallDownLoadBitMapTSPL					DownLoadBitMapTSPL;
extern CallPutBitMapTSPL						PutBitMapTSPL;
extern CallDrawBitMapTSPL						DrawBitMapTSPL;
extern CallGetPrinterStatusTSPL					GetPrinterStatusTSPL;
extern CallDriveBeepTSPL						DriveBeepTSPL;
extern CallSetCharsetNameTSPL					SetCharsetNameTSPL;
extern CallSetPaperbackOrPaperFeedTSPL			SetPaperbackOrPaperFeedTSPL;
extern CallReverseAreaTSPL						ReverseAreaTSPL;
extern CallSelectCodePageTSPL					SelectCodePageTSPL;
extern CallSetGAPTSPL							SetGAPTSPL;
extern CallSetLabelReferenceTSPL				SetLabelReferenceTSPL;
extern CallPrintTSPL21							PrintTSPL21;
extern CallSetIs21								SetIs21;
extern CallSetPrintColorTSPL				    SetPrintColorTSPL;

extern LONG m_hPrinter;

// CDialogTSPL Ի

IMPLEMENT_DYNAMIC(CDialogTSPL, CDialog)

CDialogTSPL::CDialogTSPL(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogTSPL::IDD, pParent)
{

}

CDialogTSPL::~CDialogTSPL()
{
}

void CDialogTSPL::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO2, m_PrinterType);
	DDX_Control(pDX, IDC_COMBO_BARCODETYPE, m_BarcodeType);
	DDX_Control(pDX, IDC_STATIC_BITMAP, m_strBitmapStatic);
	DDX_Control(pDX, IDC_STATIC41, m_xmStatic);
	DDX_Control(pDX, IDC_STATIC44, m_rotationStatic);
	DDX_Control(pDX, IDC_EDIT_TWOCOD_WIDTH, m_twocodwidth);
	DDX_Control(pDX, IDC_COMBO_TWOCODE_CELL_WIDTH, m_twocodecellwidth);
	DDX_Control(pDX, IDC_EDIT_TWOCOD_HEIGHT, m_twocodeheight);
	DDX_Control(pDX, IDC_COMBO_TWOCODE_LEVEL, m_twocodelevel);
	DDX_Control(pDX, IDC_STATIC_BITMAP_MODE, m_ButmapModeStatic);
}


BEGIN_MESSAGE_MAP(CDialogTSPL, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CDialogTSPL::OnCbnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON3, &CDialogTSPL::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON_PRINTLINE, &CDialogTSPL::OnBnClickedButtonPrintline)
	ON_BN_CLICKED(IDC_BUTTON_PRINTRECT, &CDialogTSPL::OnBnClickedButtonPrintrect)
	ON_BN_CLICKED(IDC_BUTTON_PRINTRECT2, &CDialogTSPL::OnBnClickedButtonPrintrect2)
	ON_BN_CLICKED(IDC_BUTTON_PRINTBARCODE, &CDialogTSPL::OnBnClickedButtonPrintbarcode)
	ON_BN_CLICKED(IDC_BUTTON_PRINTBARCODE2, &CDialogTSPL::OnBnClickedButtonPrintbarcode2)
	ON_BN_CLICKED(IDC_BUTTON_PRINTBARCODE3, &CDialogTSPL::OnBnClickedButtonPrintbarcode3)
	ON_CBN_SELCHANGE(IDC_COMBO_TWOCODE_TYPE, &CDialogTSPL::OnCbnSelchangeComboTwocodeType)
	ON_BN_CLICKED(IDC_BUTTON1, &CDialogTSPL::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CDialogTSPL::OnBnClickedButton2)
END_MESSAGE_MAP()


// CDialogTSPL Ϣ

void CDialogTSPL::ButtonInit()
{
	CString prompt;
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->SetWindowText("100");
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->SetWindowText("100");

	//ֱ
	GetDlgItem(IDC_EDIT_LINEXPOS)->SetWindowText("10");
	GetDlgItem(IDC_EDIT_LINEYPOS)->SetWindowText("10");
	GetDlgItem(IDC_EDIT_LINEWIDTH)->SetWindowText("100");
	GetDlgItem(IDC_EDIT_LINEHEIGHT)->SetWindowText("100");

	// 5,20,20,200,200
	GetDlgItem(IDC_EDIT_RECTLINEWIDTH)->SetWindowText("5");
	GetDlgItem(IDC_EDIT_TOPLEFTXPOS)->SetWindowText("20");
	GetDlgItem(IDC_EDIT_TOPLEFTYOS)->SetWindowText("20");
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMXPOS)->SetWindowText("200");
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMYPOS)->SetWindowText("200");

	// 0,0,TRUE,1,1,0,"DrawTextTSPL"
	GetDlgItem(IDC_EDIT_TEXTXPOS)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_TEXTYPOS)->SetWindowText("0");
	((CButton *)GetDlgItem(IDC_RADIO_SIMPLECHINEASE))->SetCheck(TRUE);
	((CComboBox*)GetDlgItem(IDC_COMBO_ZOOMX))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_ZOOMY))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_TEXTROTATE))->SetCurSel(0);
	prompt.LoadString(IDS_TSPL_Text);
	GetDlgItem(IDC_EDIT_TEXTCONTENT)->SetWindowText(prompt);
	
	//ӡ
	m_PrinterType.SetCurSel(1);
	GetDlgItem(IDC_STATIC_PRINTER_TYPE)->ShowWindow(SW_HIDE);
	m_PrinterType.ShowWindow(SW_HIDE);

	//TL51 ͣ"128","EAN128","39","93","EAN13","EAN8","CODA","UPCA","UPCE+5"
	//TL21  UPCAUPCEEAN13EAN839CODABAR93128
	m_BarcodeType.ResetContent();
	m_BarcodeType.AddString("UPCA");
	m_BarcodeType.AddString("UPCE");
	m_BarcodeType.AddString("EAN13");
	m_BarcodeType.AddString("EAN8");
	m_BarcodeType.AddString("39");
	m_BarcodeType.AddString("CODABAR");
	m_BarcodeType.AddString("93");
	m_BarcodeType.AddString("128");
	
	// 10,10,"128",30,TRUE,0,2,4,"123456"
	GetDlgItem(IDC_EDIT_BARCODEXPOS)->SetWindowText("10");
	GetDlgItem(IDC_EDIT_BARCODEYPOS)->SetWindowText("10");
	m_BarcodeType.SetCurSel(7);
	GetDlgItem(IDC_EDIT_BARCODEHEIGHT)->SetWindowText("30");
	((CButton *)GetDlgItem(IDC_RADIO_CODEYES))->SetCheck(TRUE);
	((CComboBox*)GetDlgItem(IDC_COMBO_BARCODEROTATE))->SetCurSel(0);
	GetDlgItem(IDC_EDIT_BARCODENARROW_WIDTH)->SetWindowText("2");
	GetDlgItem(IDC_EDIT_BARCODEWIDE_WIDTH)->SetWindowText("4");
	GetDlgItem(IDC_EDIT_BARCODECONTENT)->SetWindowText("NO.123456");
	
	//ͼƬ
	GetDlgItem(IDC_EDIT_PICXPOS)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_PICYPOS)->SetWindowText("0");
	((CButton *)GetDlgItem(IDC_RADIO_MOVEFLASH_NO))->SetCheck(TRUE);
	((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_MODE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_MODE))->AddString("OVERWRITE");
	((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_MODE))->AddString("OR");
	((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_MODE))->AddString("XOR");
    ((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_MODE))->SetCurSel(0);

	//ά
	m_xmStatic.ShowWindow(SW_HIDE);
	m_twocodwidth.ShowWindow(SW_HIDE);
	m_twocodeheight.ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT_TWOCODE_XPOS)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_TWOCODE_YPOS)->SetWindowText("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->AddString("TSPL_BT_QRCODE");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->AddString("TSPL_BT_DMATRIX");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->AddString("TSPL_BT_PDF417");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->SetCurSel(0);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("90");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("180");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("270");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("1");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("2");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("3");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("4");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("5");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("6");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("7");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("8");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("9");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("10");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->SetCurSel(0);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("7");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("15");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("25");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("30");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->SetCurSel(0);
	
	GetDlgItem(IDC_EDIT_TWOCODE_CONTENT)->SetWindowText("www.test.com");
}


BOOL CDialogTSPL::OnInitDialog()
{
	CDialog::OnInitDialog();

	ButtonInit();

	return TRUE;
}
void CDialogTSPL::OnCbnSelchangeCombo2()
{
	m_BarcodeType.ResetContent();

	if (m_PrinterType.GetCurSel() == 0){
		//TL21  UPCAUPCEEAN13EAN839CODABAR93128
		m_BarcodeType.AddString("UPCA");
		m_BarcodeType.AddString("UPCE");
		m_BarcodeType.AddString("EAN13");
		m_BarcodeType.AddString("EAN8");
		m_BarcodeType.AddString("39");
		m_BarcodeType.AddString("CODABAR");
		m_BarcodeType.AddString("93");
		m_BarcodeType.AddString("128");
		m_BarcodeType.SetCurSel(7);
	}else{
		//TL51 ͣ"128","EAN128","39","93","EAN13","EAN8","CODA","UPCA","UPCE+5"
		m_BarcodeType.AddString("128");
		m_BarcodeType.AddString("EAN128");
		m_BarcodeType.AddString("39");
		m_BarcodeType.AddString("93");
		m_BarcodeType.AddString("EAN13");
		m_BarcodeType.AddString("EAN8");
		m_BarcodeType.AddString("CODA");
		m_BarcodeType.AddString("UPCA");
		m_BarcodeType.AddString("UPCE+5");
		m_BarcodeType.SetCurSel(0);
	}
	
}

void CDialogTSPL::OnBnClickedButton3()
{
	m_strTmp.LoadString(IDS_Bitmap_File_Filter);
	CFileDialog dlg(TRUE,_T("bmp"),_T(".bmp"), OFN_NOCHANGEDIR|OFN_EXPLORER, m_strTmp, NULL, 0, TRUE);
	if(dlg.DoModal() == IDOK)
	{
		m_strImagePath = dlg.GetPathName();
		((CEdit *)GetDlgItem(IDC_EDIT_PICTUREPATH))->SetWindowText(m_strImagePath);
		ShowImage(m_strImagePath);
	}
}

void CDialogTSPL::ShowImage(CString path)
{
	CRect lRect;
	m_strBitmapStatic.GetClientRect(&lRect);

	CImage image;
	image.Load(path);
	int width = image.GetWidth();
	int height = image.GetHeight();

	int realWidth, realHeight;

	if(width > height)
	{
		realWidth = lRect.Width();
		realHeight = realWidth * height / width;
	}
	else
	{
		realHeight = lRect.Height();
		realWidth = realHeight * width / height;
	}

	//һNULL ʾʹڲԴļⲿͼƬ
	m_hCurrentSelBitmap = (HBITMAP)::LoadImage (NULL,path,IMAGE_BITMAP,realWidth,realHeight,LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	// ʾͼƬ
	m_strBitmapStatic.SetBitmap(m_hCurrentSelBitmap);

	Invalidate(TRUE);
}


void CDialogTSPL::OnBnClickedButtonPrintline()
{
	CString prompt;
	//ӡֱ
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/prompt);
		return;
	}

	CString xPos,yPos,lineWidth,lineHeight;
	GetDlgItem(IDC_EDIT_LINEXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_LINEYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_LINEWIDTH)->GetWindowText(lineWidth);
	GetDlgItem(IDC_EDIT_LINEHEIGHT)->GetWindowText(lineHeight);

	if (xPos == "" || yPos == "" || lineWidth == "" || lineHeight == ""){
		prompt.LoadString(IDS_TSPL_Line_Start);
		AfxMessageBox(/*"ֱָߵʼֱߵĿ!"*/prompt);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		SetIs21();
	}

	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//
	ret = DrawLineTSPL(m_hPrinter,atoi(xPos),atoi(yPos),atoi(lineWidth),atoi(lineHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_DrawLine);
		info.Format(/*"DrawLineTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_DrawLine_Less);
		info.Format(/*"DrawLineTSPL StartX С 0  StartY С 0  LineWidth С 0  LineHeight С 0 ʱش˴󣬴:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		PrintTSPL21(m_hPrinter,1);
	}else{
		PrintTSPL51(m_hPrinter,1,1);
	}
}

void CDialogTSPL::OnBnClickedButtonPrintrect()
{
	//ӡ
	CString prompt;

	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/prompt);
		return;
	}

	CString strLeft,strTop,strRight,strBottom,strLineWidth;
	GetDlgItem(IDC_EDIT_TOPLEFTXPOS)->GetWindowText(strLeft);
	GetDlgItem(IDC_EDIT_TOPLEFTYOS)->GetWindowText(strTop);
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMXPOS)->GetWindowText(strRight);
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMYPOS)->GetWindowText(strBottom);
	GetDlgItem(IDC_EDIT_RECTLINEWIDTH)->GetWindowText(strLineWidth);

	if (strLeft == "" || strTop == "" || strRight == "" || strBottom == "" || strLineWidth == "" ){
		prompt.LoadString(IDS_TSPL_Rectangle_Point);
		AfxMessageBox(/*"ָεĵͿ!"*/ prompt);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		SetIs21();
	}

	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//
	ret = DrawBorderTSPL(m_hPrinter,atoi(strLineWidth),atoi(strLeft),atoi(strTop),atoi(strRight),atoi(strBottom));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_DrawBorder_Error);
		info.Format(/*"DrawBorderTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_DrawBorder_Less);
		info.Format(/*"DrawBorderTSPLLineWidth < 1  top_left_x < 1  top_left_y < 1  bottom_right_x < 1  bottom_right_y < 1:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		PrintTSPL21(m_hPrinter,1);
	}else{
		PrintTSPL51(m_hPrinter,1,1);
	}

}

void CDialogTSPL::OnBnClickedButtonPrintrect2()
{
	//ӡ
	CString prompt;

	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/ prompt);
		return;
	}

	CString xPos,yPos,strContent;
	GetDlgItem(IDC_EDIT_TEXTXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_TEXTYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_TEXTCONTENT)->GetWindowText(strContent);

	if (xPos == "" || yPos == "" || strContent == "" ){
		prompt.LoadString(IDS_TSPL_Content_Point);
		AfxMessageBox(/*"ֵָĵ!"*/prompt);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		SetIs21();
	}

	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	BOOL isSimpleChinease = ((CButton*)GetDlgItem(IDC_RADIO_SIMPLECHINEASE))->GetCheck();
	INT zoomX = ((CComboBox*)GetDlgItem(IDC_COMBO_ZOOMX))->GetCurSel() + 1;
	INT zoomY = ((CComboBox*)GetDlgItem(IDC_COMBO_ZOOMY))->GetCurSel() + 1;

	INT iRotate = ((CComboBox*)GetDlgItem(IDC_COMBO_TEXTROTATE))->GetCurSel();
	INT angle = 0;
	switch (iRotate)
	{
	case 0:angle = 0;break;
	case 1:angle = 90;break;
	case 2:angle = 180;break;
	case 3:angle = 270;break;
	}
	
	//
	ret = DrawTextTSPL(m_hPrinter,atoi(xPos),atoi(yPos),isSimpleChinease,zoomX,zoomY,angle,strContent);
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_DrawText_Error);
		info.Format(/*"DrawTextTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		break;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_DrawText_Less);
		info.Format(/*"DrawTextTSPL start_x < 0  start_y < 0  xMultiplication < 1  yMultiplication < 1content == NULL,:%d"*/ prompt, ret);
		MessageBox(info);
		break;
	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_DrawText_Great);
		info.Format(/*"DrawTextTSPL xMultiplicationyMultiplication 4 :%d"*/ prompt, ret);
		MessageBox(info);
		break;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		PrintTSPL21(m_hPrinter,1);
	}else{
		PrintTSPL51(m_hPrinter,1,1);
	}

}

void CDialogTSPL::OnBnClickedButtonPrintbarcode()
{
	//ӡ
	CString prompt;
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/ prompt);
		return;
	}

	CString xPos,yPos,strContent,strNarrowWidth,strWideWidth,strCodeHeight;
	GetDlgItem(IDC_EDIT_BARCODEXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_BARCODEYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_BARCODENARROW_WIDTH)->GetWindowText(strNarrowWidth);
	GetDlgItem(IDC_EDIT_BARCODEWIDE_WIDTH)->GetWindowText(strWideWidth);
	GetDlgItem(IDC_EDIT_BARCODEHEIGHT)->GetWindowText(strCodeHeight);
	GetDlgItem(IDC_EDIT_BARCODECONTENT)->GetWindowText(strContent);
	if (xPos == "" || yPos == "" || strContent == "" ||
		strNarrowWidth == "" || strWideWidth == "" || strCodeHeight == ""){
		prompt.LoadString(IDS_TSPL_OneBar_Parameter);
		AfxMessageBox(/*"һάĲȫ!"*/ prompt);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		SetIs21();
	}

	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//һά
	CString strCodeType;
	((CComboBox*)GetDlgItem(IDC_COMBO_BARCODETYPE))->GetWindowText(strCodeType);
	BOOL isCodeYes = ((CButton*)GetDlgItem(IDC_RADIO_CODEYES))->GetCheck();

	INT iRotate = ((CComboBox*)GetDlgItem(IDC_COMBO_BARCODEROTATE))->GetCurSel();
	INT angle = 0;
	switch (iRotate)
	{
	case 0:angle = 0;break;
	case 1:angle = 90;break;
	case 2:angle = 180;break;
	case 3:angle = 270;break;
	}

	ret = DrawBarCodeTSPL(m_hPrinter,atoi(xPos),atoi(yPos),strCodeType,atoi(strCodeHeight),isCodeYes,
									angle,atoi(strNarrowWidth),atoi(strWideWidth),strContent);
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_DrawBar_Parameter_Error);
		info.Format(/*"DrawBarCodeTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_DrawBar_Less);
		info.Format(/*"DrawBarCodeTSPL start_x < 0  start_y < 0  height < 0  rotate < 0  narrowWidth < 0  wideWidth < 0 content == NULL,:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_DrawBar_Rotate);
		info.Format(/*"DrawBarCodeTSPL rotateֵ0,90,180,270 type  UPCAUPCEEAN13EAN839CODABAR93128 :%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		PrintTSPL21(m_hPrinter,1);
	}else{
		PrintTSPL51(m_hPrinter,1,1);
	}

}

void CDialogTSPL::OnBnClickedButtonPrintbarcode2()
{
	//// TODO: ڴӿؼ֪ͨ
	//LONG ret = -1;
	//CString info;
	//
	////SetIs21();//ȷϻTL21ڲָԼ
	////·δر˵ֻ֧͵ļΪͨ÷

	//ret = ClearBuffTSPL(m_hPrinter);
	//if(ret < 0)	
 //  {
	//	info.Format("ClearBuffTSPLm_hPrinter:%d",ret);
	//	MessageBox(info);
	//}
	//ret = PageSetupTSPL(m_hPrinter,100,100);
	//switch(ret)
	//{
	//	case TSPL_IDERROR:
	//		info.Format("PageSetupTSPL:%d",ret);
	//		MessageBox(info);
	//		break;
	//	case TSPL_PARAM_LESS_EQUAL_ZERO:
	//		info.Format("PageSetupTSPLPageWidthPageHeightСڻ0:%d",ret);
	//		MessageBox(info);
	//		break;

	//	case TSPL_PARAM_GREAT_RANGE:
	//		info.Format("PageSetupTSPLPageWidthPageHeightָΧ:%d",ret);
	//		MessageBox(info);
	//		break;
	//}

	//ret = DownLoadBitMapTSPL(m_hPrinter,FALSE,"E://LOGO.BMP");
	//switch(ret)
	//{
	//case TSPL_IDERROR:
	//	info.Format("DownLoadBitMapTSPL   m_hPrinter        ʧ:%d",ret);
	//	MessageBox(info);
	//	break;
	//case TSPL_PARAM_LESS_EQUAL_ZERO:
	//	info.Format("DownLoadBitMapTSPL  PathName==NULL:%d",ret);
	//	MessageBox(info);
	//	break;
	//}
	//ret = PutBitMapTSPL(m_hPrinter,0,0,"LOGO.BMP");
	//switch(ret)
	//{
	//case TSPL_IDERROR:
	//	info.Format("PutBitMapTSPL  m_hPrinter :%d",ret);
	//	MessageBox(info);
	//	break;
	//case TSPL_PARAM_LESS_EQUAL_ZERO:
	//	info.Format("PutBitMapTSPL  fileName==NULL:%d",ret);
	//	MessageBox(info);
	//	break;
	//}

	//PrintTSPL21(m_hPrinter,1);
	//return;

	//ӡͼƬ
	CString prompt;

	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/ prompt);
		return;
	}

	CString xPos,yPos,strPicturePath,strPictureName;
	GetDlgItem(IDC_EDIT_PICXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_PICYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_PICTUREPATH)->GetWindowText(strPicturePath);
	if (xPos == "" || yPos == "" || strPicturePath == ""){
		prompt.LoadString(IDS_TSPL_Bitmap_Path);
		AfxMessageBox(/*"ָͼƬ·!"*/ prompt);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		SetIs21();
	}

	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//ͼƬ
	BOOL isMoveFlash = ((CButton*)GetDlgItem(IDC_RADIO_MOVEFLASH_YES))->GetCheck();

	TRACE("strPicturePath = %s",strPicturePath);

	strPicturePath.Replace("\\","//");

	ret = DownLoadBitMapTSPL(m_hPrinter,isMoveFlash,strPicturePath/*_"E://LOGO.BMP"*/);
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_DownLoad);
		info.Format(/*"DownLoadBitMapTSPL   m_hPrinter        ʧ:%d"*/ prompt,ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_DownLoad_Parameter);
		info.Format(/*"DownLoadBitMapTSPL  PathName==NULL:%d"*/prompt, ret);
		MessageBox(info);
		return;
	}

	//ӡͼƬ
	INT posA = strPicturePath.ReverseFind('//');
	INT posB = strPicturePath.ReverseFind('.');
	INT len = strPicturePath.GetLength();
	strPictureName = strPicturePath.Mid(posA + 1,posB - posA - 1) + ".BMP";	//ͼƬչǴдBMP garland 2019-03-21
	
	ret = PutBitMapTSPL(m_hPrinter,atoi(xPos),atoi(yPos),strPictureName/*"goodwork.BMP"*/);
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_PutBitMap);
		info.Format(/*"PutBitMapTSPL  m_hPrinter :%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_PutBitMap_FileName);
		info.Format(/*"PutBitMapTSPL  fileName==NULL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		PrintTSPL21(m_hPrinter,1);
	}else{
		PrintTSPL51(m_hPrinter,1,1);
	}
}

void CDialogTSPL::OnBnClickedButtonPrintbarcode3()
{
	INT nType = 0;
	INT para1, para2,para3;
    CString strPara1,strPara2,strPara3;
	//ӡά
	//TL21
	CString prompt;
	if (m_PrinterType.GetCurSel() == 0){
		prompt.LoadString(IDS_TSPL_BarTwo_NoSupport);
		AfxMessageBox(/*"ܱǸTL21ִ֧ӡά!"*/ prompt);
		return;
	}

	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/ prompt);
		return;
	}

	CString xPos,yPos,strContent;
	GetDlgItem(IDC_EDIT_TWOCODE_XPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_TWOCODE_YPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_TWOCODE_CONTENT)->GetWindowText(strContent);
	if (xPos == "" || yPos == "" || strContent == ""){
		prompt.LoadString(IDS_TSPL_BarTwo_Content);
		AfxMessageBox(/*"ָά!"*/ prompt);
		return;
	}


	switch (((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->GetCurSel())
	{
	    case 0:
		    nType = TSPL_BT_QRCODE;
			((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->GetWindowText(strPara1);
			para1 = atoi(strPara1);
			((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->GetWindowText(strPara2);
			para2 = atoi(strPara2);
			((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->GetWindowText(strPara3);
			para3 = atoi(strPara3);
		    break;
	    case 1:
		    nType = TSPL_BT_DATAMATRIX;
			GetDlgItem(IDC_EDIT_TWOCOD_WIDTH)->GetWindowText(strPara2);
			GetDlgItem(IDC_EDIT_TWOCOD_HEIGHT)->GetWindowText(strPara1);
			para2 = atoi(strPara2);
			para1 = atoi(strPara1);
			para3 = ((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->GetCurSel();
		    break;
	    case 2:
	    	nType = TSPL_BT_PDF417;
			GetDlgItem(IDC_EDIT_TWOCOD_WIDTH)->GetWindowText(strPara2);
			GetDlgItem(IDC_EDIT_TWOCOD_HEIGHT)->GetWindowText(strPara1);
			para2 = atoi(strPara2);
			para1 = atoi(strPara1);
			((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->GetWindowText(strPara3);
			para3 = atoi(strPara3);
		    break;
		default:
			return;
	}


	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	

	ret = Draw2DBarCodeTSPL(m_hPrinter,nType,atoi(xPos),atoi(yPos),para1,para2,para3,strContent);
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Draw2D_Error);
		info.Format(/*"Draw2DBarCodeTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Draw2D_Less);
		info.Format(/*"Draw2DBarCodeTSPLstart_xstart_yСڻ0 content == NULL :%d"*/ prompt, ret);
		MessageBox(info);
		return;

	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Draw2D_Great);
		info.Format(/*"Draw2DBarCodeTSPLֵЧΧڡ :%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_INVALID:
		prompt.LoadString(IDS_TSPL_Draw2D_Invalid);
		info.Format(/*"Draw2DBarCodeTSPLֵЧֵ :%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	PrintTSPL51(m_hPrinter,1,1);

}

void CDialogTSPL::OnCbnSelchangeComboTwocodeType()
{
	switch (((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->GetCurSel())
	{
	case 2:
		SelchangePDF417();
		break;
	case 1:
		SelchangeDATAMATRIX();
		break;
	case 0:
		SelchangeQRCODE();
		break;
	}
}
void  CDialogTSPL::SelchangePDF417()
{
	CString str_prompt;
	str_prompt.LoadString(IDS_Height);
	((CEdit *)GetDlgItem(IDC_STATIC43))->SetWindowText(str_prompt);
	str_prompt.LoadString(IDS_Width);
	((CEdit *)GetDlgItem(IDC_STATIC46))->SetWindowText(str_prompt);
	m_twocodecellwidth.ShowWindow(SW_HIDE);
	m_twocodelevel.ShowWindow(SW_HIDE);
	m_xmStatic.ShowWindow(SW_HIDE);
	m_twocodwidth.ShowWindow(SW_NORMAL);
	m_twocodeheight.ShowWindow(SW_NORMAL);

	m_rotationStatic.ShowWindow(SW_NORMAL);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("90");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("180");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("270");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->SetCurSel(0);
    
}

void  CDialogTSPL::SelchangeDATAMATRIX()
{
	CString str_prompt;
	str_prompt.LoadString(IDS_Height);
	((CEdit *)GetDlgItem(IDC_STATIC43))->SetWindowText(str_prompt);
	str_prompt.LoadString(IDS_Width);
	((CEdit *)GetDlgItem(IDC_STATIC46))->SetWindowText(str_prompt);
	m_twocodecellwidth.ShowWindow(SW_HIDE);
	m_twocodelevel.ShowWindow(SW_HIDE);
	m_rotationStatic.ShowWindow(SW_HIDE);
	m_twocodwidth.ShowWindow(SW_NORMAL);
	m_xmStatic.ShowWindow(SW_NORMAL);
	m_twocodeheight.ShowWindow(SW_NORMAL);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("x1");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("x2");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("x3");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("x4");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("x5");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("x6");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->SetCurSel(0);

}
void  CDialogTSPL::SelchangeQRCODE()
{
	CString str_prompt;
	str_prompt.LoadString(IDS_CELL_WIDTH);
	((CEdit *)GetDlgItem(IDC_STATIC43))->SetWindowText(str_prompt);
	str_prompt.LoadString(IDS_LEVEL);
	((CEdit *)GetDlgItem(IDC_STATIC46))->SetWindowText(str_prompt);
	m_xmStatic.ShowWindow(SW_HIDE);
	m_twocodwidth.ShowWindow(SW_HIDE);
	m_twocodeheight.ShowWindow(SW_HIDE);
	m_twocodecellwidth.ShowWindow(SW_NORMAL);
	m_twocodelevel.ShowWindow(SW_NORMAL);
	m_rotationStatic.ShowWindow(SW_NORMAL);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("90");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("180");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->AddString("270");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_SIZE))->SetCurSel(0);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("1");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("2");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("3");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("4");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("5");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("6");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("7");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("8");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("9");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->AddString("10");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_CELL_WIDTH))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("7");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("15");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("25");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("30");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->SetCurSel(0);
}
void CDialogTSPL::OnBnClickedButton1()
{
	// TODO: ڴӿؼ֪ͨ
	//ӡͼƬ
	CString prompt;
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(/*"ָҳ!"*/ prompt);
		return;
	}
	CString xPos,yPos,strPicturePath,strPictureName;
	GetDlgItem(IDC_EDIT_PICXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_PICYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_PICTUREPATH)->GetWindowText(strPicturePath);
	if (xPos == "" || yPos == "" || strPicturePath == ""){
		prompt.LoadString(IDS_TSPL_Bitmap_Path);
		AfxMessageBox(/*"ָͼƬ·!"*/ prompt);
		return;
	}
	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}
	ret = PageSetupTSPL(m_hPrinter,atoi(m_strPageWidth),atoi(m_strPageHeight));
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_Setup_Error);
		info.Format(/*"PageSetupTSPL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_Parameter_Less);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightСڻ0:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_GREAT_RANGE:
		prompt.LoadString(IDS_TSPL_Parameter_Great);
		info.Format(/*"PageSetupTSPLPageWidthPageHeightָΧ:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}
	//ӡͼƬ
	INT posA = strPicturePath.ReverseFind('//');
	INT posB = strPicturePath.ReverseFind('.');
	INT len = strPicturePath.GetLength();
	strPictureName = strPicturePath.Mid(posA + 1,posB - posA - 1) + ".BMP";	//ͼƬչǴдBMP garland 2019-03-21
	ret = DrawBitMapTSPL(m_hPrinter,atoi(xPos),atoi(yPos),((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_MODE))->GetCurSel(),strPictureName/*"goodwork.BMP"*/);
	switch(ret)
	{
	case TSPL_IDERROR:
		prompt.LoadString(IDS_TSPL_PutBitMap);
		info.Format(/*"DrawBitMapTSPL  m_hPrinter :%d"*/ prompt, ret);
		MessageBox(info);
		return;
	case TSPL_PARAM_LESS_EQUAL_ZERO:
		prompt.LoadString(IDS_TSPL_PutBitMap_FileName);
		info.Format(/*"DrawBitMapTSPL  fileName==NULL:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}
	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		PrintTSPL21(m_hPrinter,1);
	}else{
		PrintTSPL51(m_hPrinter,1,1);
	}
}

void CDialogTSPL::OnBnClickedButton2()
{
	// TODO: ڴӿؼ֪ͨ
	//ӡ
	CString prompt;
	CString strContent;
	SYSTEMTIME tmpSys;
	GetLocalTime(&tmpSys);
	

	//TL21
	if (m_PrinterType.GetCurSel() == 0){
		SetIs21();
	}

	CString info;
	LONG ret = ClearBuffTSPL(m_hPrinter);
	if(ret < 0)	
	{
		prompt.LoadString(IDS_TSPL_Clear_Buffer);
		info.Format(/*"ClearBuffTSPLm_hPrinter:%d"*/ prompt, ret);
		MessageBox(info);
		return;
	}

	
    PageSetupTSPL(m_hPrinter,56,90);
	SetPrintColorTSPL(m_hPrinter,0);
	ret = DrawBorderTSPL(m_hPrinter,1,8,8,432,704);
	strContent.Format("%4d/%02d/%02d %d:%d:%d",tmpSys.wYear, tmpSys.wMonth, tmpSys.wDay,tmpSys.wHour,tmpSys.wMinute,tmpSys.wSecond);
	//
	SetPrintColorTSPL(m_hPrinter,0);
	ret = DrawTextTSPL(m_hPrinter,16,108,TRUE,1,1,0,strContent);
    SetPrintColorTSPL(m_hPrinter,1);
    ret = DrawBitMapTSPL(m_hPrinter,256,16,0,"1.bmp");
    SetPrintColorTSPL(m_hPrinter,0);
	strContent = "356-01-02";
	ret = DrawTextTSPL(m_hPrinter,16,152,TRUE,2,2,0,strContent);
	strContent = "A0F3";
	ret = DrawTextTSPL(m_hPrinter,264,152,TRUE,2,2,0,strContent);
	ret = DrawLineTSPL(m_hPrinter,8,200,424,1);
	strContent = "368806661326";
	CString strCodeType = "128";
	ret = DrawBarCodeTSPL(m_hPrinter,16,224,strCodeType,120,TRUE,
		0,4,8,strContent);
    ret = DrawLineTSPL(m_hPrinter,8,392,424,1);
	strContent = "³ľת";
	ret = DrawTextTSPL(m_hPrinter,16,408,TRUE,2,2,0,strContent);
	ret = DrawLineTSPL(m_hPrinter,280,392,1,88);
	SetPrintColorTSPL(m_hPrinter,1);
	ret = DrawBitMapTSPL(m_hPrinter,296,400,0,"2.bmp");
	
	SetPrintColorTSPL(m_hPrinter,0);
	ret = DrawLineTSPL(m_hPrinter,8,480,424,1);
	ret = DrawLineTSPL(m_hPrinter,72,480,1,224);
	strContent = "ͨ   186****7845";
	ret = DrawTextTSPL(m_hPrinter,98,504,TRUE,1,1,0,strContent);
	SetPrintColorTSPL(m_hPrinter,1);
	ret = DrawBitMapTSPL(m_hPrinter,328,488,0,"3.bmp");
	SetPrintColorTSPL(m_hPrinter,0);
	strContent = "";
	ret = DrawTextTSPL(m_hPrinter,16,536,TRUE,1,1,0,strContent);
	strContent = "ϺлϪ";
	ret = DrawTextTSPL(m_hPrinter,98,536,TRUE,1,1,0,strContent);
	ret = DrawLineTSPL(m_hPrinter,8,576,424,1);
	strContent = "  139****8888";
	ret = DrawTextTSPL(m_hPrinter,98,592,TRUE,1,1,0,strContent);
	strContent = "";
	ret = DrawTextTSPL(m_hPrinter,16,632,TRUE,1,1,0,strContent);
	strContent = "";
	ret = DrawTextTSPL(m_hPrinter,98,632,TRUE,1,1,0,strContent);

	PrintTSPL51(m_hPrinter,1,1);

}
